local jkHouses = ...

jkHouses:registerAssetProcessor("models/house_extensions.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

jkHouses:registerAssetId("models/house_extensions.fbx/Materials/wall_7", MOD_NS .. "MAIN_WALL_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/roof_3", MOD_NS .. "MAIN_ROOF_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/roof_6", MOD_NS .. "DARK_RED_ROOF_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/roof_dark", MOD_NS .. "DARK_ROOF_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/light_wood", MOD_NS .. "BASE_WOOD_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/stone_wall_2", MOD_NS .. "BASE_STONE_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/stone_wall", MOD_NS .. "ALT_STONE_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/wall_9", MOD_NS .. "PINK_WALL_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/wall_11", MOD_NS .. "PINK_TOWER_WALL_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/wall_8", MOD_NS .. "YELLOW_WALL_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/wall_5", MOD_NS .. "BASE_TOWER_WALL_MATERIAL")
jkHouses:registerAssetId("models/house_extensions.fbx/Materials/wall_10", MOD_NS .. "YELLOW_TOWER_WALL_MATERIAL")

registerStaticPart("models/house_extensions.fbx/Prefab/RoofAPart", "ROOF_A", "ROOF")
registerStaticPart("models/house_extensions.fbx/Prefab/RoofBPart", "ROOF_B", "ROOF")
registerStaticPart("models/house_extensions.fbx/Prefab/RoofCPart", "ROOF_C", "ROOF")

registerMinorStaticPart("models/house_extensions.fbx/Prefab/WindowAPart", "WINDOW_A", "WINDOW")
registerMinorStaticPart("models/house_extensions.fbx/Prefab/WindowBPart", "WINDOW_B", "WINDOW")
registerMinorStaticPart("models/house_extensions.fbx/Prefab/WindowCPart", "WINDOW_C", "WINDOW")
registerMinorStaticPart("models/house_extensions.fbx/Prefab/WindowDPart", "WINDOW_D", "WINDOW")

registerMinorStaticPart("models/house_extensions.fbx/Prefab/ChimneyAPart", "CHIMNEY_A", "CHIMNEY")
registerSmokeEmitterPart("models/house_extensions.fbx/Prefab/ChimneyAPart", "ChimneyA")

registerMinorStaticPart("models/house_extensions.fbx/Prefab/DoorAPart", "DOOR_A", "DOOR", "DOOR", polygon.createRectangle( {2, 2.5}, {0, -1}))
registerMinorStaticPart("models/house_extensions.fbx/Prefab/DoorBPart", "DOOR_B", "DOOR", "DOOR", polygon.createRectangle( {2, 2.5}, {0, -1}))

registerMinorStaticPart("models/house_extensions.fbx/Prefab/RoofWindowAPart", "ROOF_WINDOW_A", "ROOF_WINDOW")
registerMinorStaticPart("models/house_extensions.fbx/Prefab/RoofWindowBPart", "ROOF_WINDOW_B", "ROOF_WINDOW")

jkHouses:registerAssetId("models/house_extensions.fbx/Prefab/DummyPart", MOD_NS .. "PREFAB_E_DUMMY")
jkHouses:registerPrefabComponent("models/house_extensions.fbx/Prefab/DummyPart", {
	DataType = "COMP_GROUNDED",
	AutoDisable = true
})

jkHouses:registerAsset({
	DataType = "BUILDING_PART",
	Id = MOD_NS .. "E_DUMMY_PART",
	Description = "",
	Capacity = 0,
	Category = "CORE",
	ConstructionVisual = MOD_NS .. "PREFAB_E_DUMMY",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = MOD_NS .. "PREFAB_E_DUMMY"
	}
})


local houseFunction = registerHouseFunction("MODULAR_HOUSE", "HOUSING_LEVEL_1", "E_DUMMY_PART")
local houseExtensionFunction = registerHouseFunction("MODULAR_HOUSE_EXTENSION", "HOUSING_LEVEL_2", "E_DUMMY_PART")

jkHouses:registerAsset({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = MOD_NS .. "BUILDING_FUNCTION_LIST_MODULES",
    AssetFunctionList = {
        houseFunction,
        houseExtensionFunction,
    }
})

local extFunction = MOD_NS .. "FUNCTION_EXTENDED_MODULES"
jkHouses:registerAsset({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = extFunction,
    AuthorizedFunctionList = MOD_NS .. "BUILDING_FUNCTION_LIST_MODULES"
})

local prefabPath = "models/house_extensions.fbx/Prefab/"

registerScalableExtension(prefabPath, "A", "EXTENSION", {2.8, 1.5}, 1, extFunction)
registerScalableExtension(prefabPath, "B", "CORE", {3, 4.2}, 1, extFunction)
registerScalableExtension(prefabPath, "C", "RIGHT_EXTENSION", {1.5, 4.2}, 0, extFunction)
registerScalableExtension(prefabPath, "D", "LEFT_EXTENSION", {1.5, 4.2}, 0, extFunction)
registerScalableExtension(prefabPath, "F", "TOWER", { 2.3, 2.3 }, 1, extFunction)

registerMinorScalableExtensionNoBasement(prefabPath, "E", "SMALL_TOWER", 1)
registerMinorScalableExtensionNoBasement(prefabPath, "G", "BALCONY", 1)