local jkHouses = ...

jkHouses:registerAssetProcessor("models/court_properties.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})


jkHouses:registerAssetId("models/water.png", MOD_NS .. "WATER_TEXTURE")

jkHouses:registerAssetId("models/court_properties.fbx/Materials/water", MOD_NS .. "TRANSPARENT_WATER")
jkHouses:overrideAsset({
    Id = MOD_NS .. "TRANSPARENT_WATER",
    RenderMode = MATERIAL_RENDER_MODE.UNLIT,
	BackFaceVisible = false,
    HasShadow = false,
    Metalness = 0.9,
})

jkHouses:registerAssetId("models/court_properties.fbx/Prefab/FountainPart", MOD_NS .. "PREFAB_FOUNTAIN")
jkHouses:registerPrefabComponent("models/court_properties.fbx/Prefab/FountainPart", {
    DataType = "COMP_DIRT_CIRCLE",
    HardRadius = 1,
    IsPermanent = true
})

jkHouses:registerAsset({
    DataType = "BUILDING_PART",
    Id = MOD_NS .. "FOUNTAIN_PART",
    Description = "",
    Category = "CORE",
    ConstructionVisual = MOD_NS .. "PREFAB_FOUNTAIN",
    AssetBuildingFunction = "BUILDING_FUNCTION_WELL",
    ConstructorData = {
        DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
        CoreObjectPrefab = MOD_NS .. "PREFAB_FOUNTAIN"
    },
    BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = {
                    { 0.8, 0 },
                    { 0.4, 0.7 },
                    { -0.4, 0.7 },
                    { -0.8, 0 },
                    { -0.4, -0.7 },
                    { 0.4, -0.7 }
                },
                Type = { DEFAULT = true, NAVIGABLE = false, GRASS_CLEAR = true } 
            }
        }
    },
    DesirabilityModifiers = {
        {
                Desirability = "DESIRABILITY_RESIDENTIAL",
                Radius = 25,
                Value = 0.2
        }
    },
    Cost = {
        BuildRightTaxes = {
            { Resource = "GOLD_COINS", Quantity = 20 }
        },
        UpkeepCost = {
            { Resource = "GOLD_COINS", Quantity = 5 }
        },
        ResourceNeededList = {
            {
                { Resource = "WOOD", Quantity = 10 },
                { Resource = "STONE", Quantity = 5 }
            }
        }
    }
})
jkHouses:register({
    DataType = "BUILDING",
    Id = MOD_NS .. "FOUNTAIN",
    Name = MOD_NS .. "FOUNTAIN_NAME",
    BuildingType = BUILDING_TYPE.HOUSING,
    AssetCoreBuildingPart = MOD_NS .. "FOUNTAIN_PART",
    IsDestructible = true,
    IsClearTrees = true
})